﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;
using System.Windows.Input;
using Dapfor.Wpf.Controls;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.HitTests
{
    class CellInfoConverter : IValueConverter
    {
        public enum InfoType
        {
            Value,
            ValueType,
            Text,
        }

        public InfoType Info { get; set; }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var grid = (GridControl)value;
            Point position = Mouse.GetPosition(grid);
            Cell cell = grid.HitTests.CellTest(position);
            if (cell != null)
            {
                switch (Info)
                {
                    case InfoType.Value: return cell.Value;
                    case InfoType.ValueType: return cell.Value != null ? cell.Value.GetType() : null;
                    case InfoType.Text: return cell.Text;
                }
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
    }
}
