﻿using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows.Controls;
using Dapfor.Wpf.Grid.Demo.Internal;

namespace Dapfor.Wpf.Grid.Demo.Examples.Basics.SmartColumnFiltersAndGrouping
{
    /// <summary>
    /// Interaction logic for SmartColumnFiltersAndGroupingDemo.xaml
    /// </summary>
    [Example("Basics", "Smart filters and grouping", "Description_SmartColumnFiltersAndGroupingDemo")]
    public partial class SmartColumnFiltersAndGroupingDemo : UserControl
    {
        public SmartColumnFiltersAndGroupingDemo()
        {
            InitializeComponent();


            IList<MyDataObject> collection = new ObservableCollection<MyDataObject>();

            collection.Add(new MyDataObject("Family", "Dave Carder", "Torn Asunder", 8.99m));
            collection.Add(new MyDataObject("Fiction", "Nina Kari", "Forbidden Fantasy", 5.99m));
            collection.Add(new MyDataObject("Fantasy", "Asher Elliot", "The Outlaw's Quest", 2.99m));
            collection.Add(new MyDataObject("Fiction", "Asher Elliot", "Keeper of the Books", 2.99m));
            collection.Add(new MyDataObject("Fantasy", "Jonathan Moeller", "Frostborn: The Knight Quests", 2.99m));
            collection.Add(new MyDataObject("Fantasy", "Jonathan Moeller", "Ghost Mimic", 1.99m));
            collection.Add(new MyDataObject("Fiction", "Jonathan Moeller", "Ghost in the Pact", 1.99m));
            collection.Add(new MyDataObject("Fiction", "Jonathan Moeller", "The Bronze Knight", 1.99m));

            collection.Add(new MyDataObject("Fiction", "Hiranya Borah", "Guilt:Gift of Winter Spring", 0));
            collection.Add(new MyDataObject("Fiction", "Hiranya Borah", "How To Become Unpopular", 0));

            collection.Add(new MyDataObject("Fiction", "Henry Moa", "La Confederacion del Crimen", 2.99m));
            collection.Add(new MyDataObject("History", "Henry Moa", "Der Aufstand des Zanj", 2.99m));
            collection.Add(new MyDataObject("History", "Henry Moa", "El Emperio de Los Esclavos Coronados", 2.99m));
            collection.Add(new MyDataObject("Adventure", "Henry Moa", "The Confederation of Crime", 2.99m));


            collection.Add(new MyDataObject("Adventure", "Julie Coulter Bellon", "On the Edge", 3.99m));
            collection.Add(new MyDataObject("Adventure", "Julie Coulter Bellon", "Ring Around the Rosie", 4.99m));
            collection.Add(new MyDataObject("Fiction", "Julie Coulter Bellon", "Falling Slowly", 4.99m));
            collection.Add(new MyDataObject("Thriller", "Julie Coulter Bellon", "The Captive", 4.99m));

            collection.Add(new MyDataObject("Thriller", "Barry Hunt", "Bad Blood", 2.99m));
            collection.Add(new MyDataObject("Thriller", "Barry Hunt", "The Maddalena Project", 2.99m));
            collection.Add(new MyDataObject("Thriller", "Barry Hunt", "The Code-breaker", 2.99m));
            collection.Add(new MyDataObject("Fiction", "Barry Hunt", "Julius and the Black Hand", 2.99m));
            collection.Add(new MyDataObject("Fiction", "Barry Hunt", "Julius and the Titanic", 2.99m));

            collection.Add(new MyDataObject("Fiction", "Richard Abshire", "Turnaround Jack", 3.99m));
            collection.Add(new MyDataObject("Fiction", "Richard Abshire", "The Dallas Deception", 3.99m));
            collection.Add(new MyDataObject("Fiction", "Richard Abshire", "Dallas Drop: A Jack Kyle Mystery", 3.99m));
  
            grid.ItemsSource = collection;


            for(int i = 5; i < 15; ++i)
            {
                grid.Rows[i].Selected = true;
            }

            cbGroupRows.IsChecked = true;
        }

        private void OnGroupRowsChanged(object sender, System.Windows.RoutedEventArgs e)
        {
            if (cbGroupRows.IsChecked != null && cbGroupRows.IsChecked.Value)
            {
                grid.Headers[0]["Category"].Grouped = true;
                grid.Headers[0]["Category"].Visible = false;
            }
            else
            {
                grid.Headers[0]["Category"].Grouped = false;
                grid.Headers[0]["Category"].Visible = true;
            }


        }
    }
}
