﻿using System;
using System.Collections.Generic;
using Dapfor.Wpf.Controls;
using Dapfor.Wpf.Grid.Demo.Internal;

namespace Dapfor.Wpf.Grid.Demo.Examples.DataBinding.SharedData
{
    /// <summary>
    /// Interaction logic for SharedDataDemo.xaml
    /// </summary>
    [Example("Data binding", "Shared data", "Description_SharedData")]
    public partial class SharedDataDemo 
    {
        public string Description
        {
            get { return "this is a desacrition !!!"; }
        }

        public SharedDataDemo()
        {
            InitializeComponent();

            //Populate data
            PopulateGrids();
        }

        private void PopulateGrids()
        {
            var random = new Random();
            var dataObjects = new List<DataObject>();
            for (int i = 0; i < 8; ++i)
            {
                dataObjects.Add(new DataObject(string.Format("Id{0}", i), random));
            }

            //Populate the grid
            grid1.ItemsSource = dataObjects;


            //Add root rows to the grid2
            Row root1 = grid2.Rows.Add(new RootDataObject("Node 0: To expand or collapse this node double click on the row."));
            Row root2 = grid2.Rows.Add(new RootDataObject("Node 1: To expand or collapse this node double click on the row."));

            //Add 4 children to the root1
            for (int i = 0; i < 4; ++i)
            {
                root1.Add(dataObjects[i]);
            }
            //Add 4 children to the root2
            for (int i = 4; i < dataObjects.Count; ++i)
            {
                root2.Add(dataObjects[i]);
            }
            grid2.Rows.ExpandAll();
        }
    }
}