﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using Dapfor.Wpf.Converters;
using Dapfor.Wpf.Data;

namespace Dapfor.Wpf.Grid.Demo.Examples.Miscellaneous.FileExplorer
{
    class FileObject : IExplorable
    {
        private readonly FileAttributes _attributes;
        private readonly IExplorable _baseExplorable;
        private readonly DateTime _creationDate;
        private readonly string _name;
        private readonly long _size;

        public FileObject(string name, DateTime creationDate, long size, FileAttributes attributes, IExplorable baseExplorable)
        {
            _name = name;
            _creationDate = creationDate;
            _size = size;
            _attributes = attributes;
            _baseExplorable = baseExplorable;
        }

        [Field("IdName")]
        public string FileName
        {
            get { return _name; }
        }

        [Field("IdDate")]
        public DateTime CreationDate
        {
            get { return _creationDate; }
        }

        [Field("Attributes")]
        public FileAttributes Attributes
        {
            get { return _attributes; }
        }

        [Field("IdSize")]
        [Converter(typeof(SizeCustomConverter))]
        public long Size
        {
            get { return _size; }
        }

        #region IExplorable Members

        public string FullName
        {
            get { return _baseExplorable.FullName + _name; }
        }

        public bool Expandable
        {
            get { return false; }
        }

        #endregion
    }
}
