﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using Dapfor.Wpf.Controls;
using Dapfor.Wpf.Grid.Demo.Internal;
using Dapfor.Wpf.Utils;

namespace Dapfor.Wpf.Grid.Demo.Examples.WhyUs.PreservingSelection
{
    /// <summary>
    ///     Interaction logic for PreservingSelectionDemo.xaml
    /// </summary>
    [Example("Why us?", "Preserving selection when filtering", "Description_WhyUsPreservingSelection")]
    public partial class PreservingSelectionDemo : UserControl
    {
        public PreservingSelectionDemo()
        {
            InitializeComponent();


            IList<CustomDataObject> collection = new ObservableCollection<CustomDataObject>();

            collection.Add(new CustomDataObject("Family", "Dave Carder", "Torn Asunder", 8.99m));
            collection.Add(new CustomDataObject("Fiction", "Nina Kari", "Forbidden Fantasy", 5.99m));
            collection.Add(new CustomDataObject("Fantasy", "Asher Elliot", "The Outlaw's Quest", 2.99m));
            collection.Add(new CustomDataObject("Fiction", "Asher Elliot", "Keeper of the Books", 2.99m));
            collection.Add(new CustomDataObject("Fantasy", "Jonathan Moeller", "Frostborn: The Knight Quests", 2.99m));
            collection.Add(new CustomDataObject("Fantasy", "Jonathan Moeller", "Ghost Mimic", 1.99m));
            collection.Add(new CustomDataObject("Fiction", "Jonathan Moeller", "Ghost in the Pact", 1.99m));
            collection.Add(new CustomDataObject("Fiction", "Jonathan Moeller", "The Bronze Knight", 1.99m));

            collection.Add(new CustomDataObject("Fiction", "Hiranya Borah", "Guilt:Gift of Winter Spring", 0));
            collection.Add(new CustomDataObject("Fiction", "Hiranya Borah", "How To Become Unpopular", 0));

            collection.Add(new CustomDataObject("Fiction", "Henry Moa", "La Confederacion del Crimen", 2.99m));
            collection.Add(new CustomDataObject("History", "Henry Moa", "Der Aufstand des Zanj", 2.99m));
            collection.Add(new CustomDataObject("History", "Henry Moa", "El Emperio de Los Esclavos Coronados", 2.99m));
            collection.Add(new CustomDataObject("Adventure", "Henry Moa", "The Confederation of Crime", 2.99m));


            collection.Add(new CustomDataObject("Adventure", "Julie Coulter Bellon", "On the Edge", 3.99m));
            collection.Add(new CustomDataObject("Adventure", "Julie Coulter Bellon", "Ring Around the Rosie", 4.99m));
            collection.Add(new CustomDataObject("Fiction", "Julie Coulter Bellon", "Falling Slowly", 4.99m));
            collection.Add(new CustomDataObject("Thriller", "Julie Coulter Bellon", "The Captive", 4.99m));

            collection.Add(new CustomDataObject("Thriller", "Barry Hunt", "Bad Blood", 2.99m));
            collection.Add(new CustomDataObject("Thriller", "Barry Hunt", "The Maddalena Project", 2.99m));
            collection.Add(new CustomDataObject("Thriller", "Barry Hunt", "The Code-breaker", 2.99m));
            collection.Add(new CustomDataObject("Fiction", "Barry Hunt", "Julius and the Black Hand", 2.99m));
            collection.Add(new CustomDataObject("Fiction", "Barry Hunt", "Julius and the Titanic", 2.99m));

            collection.Add(new CustomDataObject("Fiction", "Richard Abshire", "Turnaround Jack", 3.99m));
            collection.Add(new CustomDataObject("Fiction", "Richard Abshire", "The Dallas Deception", 3.99m));
            collection.Add(new CustomDataObject("Fiction", "Richard Abshire", "Dallas Drop: A Jack Kyle Mystery", 3.99m));

            grid.ItemsSource = collection;

            for (int i = 5; i < 15; ++i)
            {
                grid.Rows[i].Selected = true;
            }

            grid.Headers[0]["Price"].SortDirection = SortDirection.Ascending;
        }

        private void OnGroupRowsChanged(object sender, RoutedEventArgs e)
        {
            if (cbGroupRows.IsChecked != null && cbGroupRows.IsChecked.Value)
            {
                grid.Headers[0]["Category"].Grouped = true;
                grid.Headers[0]["Category"].Visible = false;
            }
            else
            {
                grid.Headers[0]["Category"].Grouped = false;
                grid.Headers[0]["Category"].Visible = true;
            }

        }

        private void OnFilterRowsChanged(object sender, RoutedEventArgs e)
        {
            if (cbFilterRows.IsChecked != null && cbFilterRows.IsChecked.Value)
            {
                grid.Filter = new Filter(row =>
                {
                    if (row["Book"].Text.Contains("th") || row["Book"].Text.Contains("Th"))
                    {
                        return true;
                    }

                    return false;
                });
            }
            else
            {
                grid.Filter = null;
            }
        }
    }
}