﻿using System;
using System.Windows;

namespace Dapfor.Wpf.Grid.Demo.GenericControls
{
    /// <summary>
    /// Interaction logic for PlusMinusControl.xaml
    /// </summary>
    public partial class PlusMinusControl
    {
        #region Value dependency property

        internal static readonly DependencyProperty ValueProperty = DependencyProperty.Register("Value", typeof(double), typeof(PlusMinusControl), new PropertyMetadata(0d));
        internal double Value
        {
            get { return (double)GetValue(ValueProperty); }
            set
            {
                if (value != Value)
                {
                    SetValue(ValueProperty, value);    
                }
            }
        }

        #endregion

        public PlusMinusControl()
        {
            InitializeComponent();

            MinValue = 0;
            MaxValue = int.MaxValue;
        }

        public double MinValue { get; set; }

        public double MaxValue { get; set; }

        private void btnDecrement_Click(object sender, RoutedEventArgs e)
        {
            Value = Math.Max(MinValue, Value - 1d);
        }

        private void btnIncrement_Click(object sender, RoutedEventArgs e)
        {
            Value = Math.Min(MaxValue, Value + 1d);
        }
    }
}